
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the MSERVCLI_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// MSERVCLI_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifdef MSERVCLI_EXPORTS
#define MSERVCLI_API __declspec(dllexport)
#else
#define MSERVCLI_API __declspec(dllimport)
#endif

#include <sys/types.h>
#include <stdio.h>

struct mservcli_data {
  unsigned int maxparams;
  unsigned int params;
  char **param;
};

struct mservcli_id {
  int sock;
  FILE *in, *out;
  int rtflag;
  int bufmine;
  char *buffer;
  unsigned int buflen;
  void (*rt_handler)(void *, int, struct mservcli_data *);
  void *rt_private;
  struct mservcli_data *rt_data;
};

MSERVCLI_API struct mservcli_id *mservcli_connect(const struct sockaddr_in *servaddr,
				     char *buffer, unsigned int buflen,
				     const char *user, const char *pass,
				     int rtflag);
MSERVCLI_API int mservcli_free(struct mservcli_id *id);
MSERVCLI_API int mservcli_rthandler(struct mservcli_id *id,
                       void (*rth)(void *, int, struct mservcli_data *),
                       void *privateData,
                       struct mservcli_data *data);
MSERVCLI_API int mservcli_getresult(struct mservcli_id *id);
MSERVCLI_API char *mservcli_getresultstr(struct mservcli_id *id);
MSERVCLI_API int mservcli_getdata(struct mservcli_id *id, struct mservcli_data *data);
MSERVCLI_API int mservcli_send(struct mservcli_id *id, const char *output);
MSERVCLI_API int mservcli_discarddata(struct mservcli_id *id);
MSERVCLI_API int mservcli_poll(struct mservcli_id *id);
