#include <stdio.h>
#include "mservcli.h"
#include <winsock.h>
#include <errno.h>

#define REALTIME_TEST 1

#ifdef REALTIME_TEST

struct mservcli_data mservData;

void rtHand(void *junk, int rc, struct mservcli_data *msDat);
char* rtParams[64];

#endif

int main() {
  struct sockaddr_in sin;
  struct hostent *hent;
  struct mservcli_id *id;
  int err;

  WORD wsVersion;
  WSADATA boringWSjunk;

  wsVersion = MAKEWORD(1, 1);

  err = WSAStartup(wsVersion, &boringWSjunk);

  if (err != 0) {
    fprintf(stderr, "oh, I can't be bothered to deal with winsock not initialising.\n");
	exit(1);
  }

  if ((hent = gethostbyname("ruffles.spodnet.org")) == NULL) {
    err = WSAGetLastError();
	fprintf(stderr, "mservclitest: unknown host (%d)\n", err);
    exit(2);
  }

  sin.sin_family = AF_INET;
  sin.sin_port = htons(4444);
  sin.sin_addr = *(struct in_addr *)hent->h_addr_list[0];
  for(err=0;err<8;err++) *(sin.sin_zero+err) = 0;

#ifdef REALTIME_TEST
  mservData.param = rtParams;
  mservData.maxparams = 64;

  if ((id = mservcli_connect(&sin, NULL, 0, "guest", "guest", 1)) == NULL) {
#else
  if ((id = mservcli_connect(&sin, NULL, 0, "guest", "guest", 0)) == NULL) {
#endif
    err = WSAGetLastError();
    if (errno == EACCES) {
      fprintf(stderr, "mservclitest: server said access denied\n");
      exit(1);
    }
    fprintf(stderr, "mservclitest: unable to connect to server: %s (%d)\n",
            strerror(errno), err);
    exit(1);
  }

  printf("coo, it worked.\n");

#ifdef REALTIME_TEST

  printf("registering...");

  if(mservcli_rthandler(id, &rtHand, NULL, &mservData) == -1) {
    printf("rthandler failed, hmph (%d)\n", errno);
    exit(1);
  }
  printf("success!\n");

  for(;;) {
    printf("waiting 10...\n");
    Sleep(10000);
    printf("time up, checking\n");
    if(mservcli_poll(id)==-1) {
      printf("poll failed (%d)\n", errno);
      exit(1);
    }
  }

#endif

  mservcli_free(id);

  return 0;
}

#ifdef REALTIME_TEST

void rtHand(void *junk, int rc, struct mservcli_data *msDat) {
  unsigned int i;

  printf("got a %d - ", rc);

  for(i=0;i<msDat->params;i++) printf("%s,",msDat->param[i]);
 
  printf("\n");
}

#endif